// Copyright (c) 2016, Ravi Teja Gudapati. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'package:jaguar_query/jaguar_query.dart';

main() {
  FindStatement find = Sql.find
      .from('posts')
      .sel('message')
      .where(col('likes').eq(10) & Col.int('replies').eq(5))
      .where(eq('author', 'teja') | like('author', 'kleak*'))
      .orderBy('author', true)
      .limit(10)
      .groupByMany(['message', 'likes']);

  print(find.toSql());

  InsertStatement insert = Sql.insert
      .into('posts')
      .setIdValue('id', 1)
      .setValue('message', 'How are you?')
      .setValue('author', 'teja')
      .setValues({'likes': 0, 'replies': 0});

  print(insert.toSql());

  UpdateStatement update =
      Sql.update.into('posts').eq('author', 'teja').setValue('likes', 1);

  print(update.toSql());

  DeleteStatement delete = Sql.delete.from('posts').where(eq('author', 'teja'));

  print(delete.toSql());

  UpdateStatement update1 =
      Sql.update.into('posts').eq('likes', 5).setValue('likes', 1);

  print(update1.toSql());

  FindStatement find1 = Sql.find
      .from('posts')
      .where(eqCol('author', col('id', 'authors')))
      .orderBy('author', true)
      .limit(10)
      .groupByMany(['message', 'likes']);

  print(find1.toSql());
}
