part of query;

class DropTableStatement implements Statement {
  final List<String> _tables = [];

  bool _onlyIfExists = false;

  UnmodifiableListView<String> get tables => new UnmodifiableListView(_tables);

  DropTableStatement();

  DropTableStatement named(String table) {
    _tables.add(table);
    return this;
  }

  DropTableStatement many(List<String> table) {
    _tables.addAll(table);
    return this;
  }

  DropTableStatement onlyIfExists() {
    _onlyIfExists = true;
    return this;
  }

  String toSql() {
    return "DROP TABLE " +
        (_onlyIfExists ? 'IF EXISTS ' : '') +
        _tables.join(', ');
  }
}
