part of query;

class InsertStatement implements Statement {
  String _tableName;

  String _id;

  final Map<String, dynamic> _values = {};

  InsertStatement();

  InsertStatement into(String tableName) {
    if (_tableName != null) {
      throw new Exception("Name already assigend!");
    }
    _tableName = tableName;
    return this;
  }

  InsertStatement id(String id) {
    _id = id;
    return this;
  }

  InsertStatement setId<ValType>(SetColumn<ValType> column) {
    _id = column._column;
    return set<ValType>(column);
  }

  InsertStatement set<ValType>(SetColumn<ValType> column) {
    setValue(column._column, column._value);
    return this;
  }

  InsertStatement setMany(List<SetColumn> columns) {
    columns.forEach((SetColumn column) {
      setValue(column._column, column._value);
    });
    return this;
  }

  InsertStatement setIdValue<ValType>(String column, ValType value) {
    _id = column;
    return setValue<ValType>(column, value);
  }

  InsertStatement setValue<ValType>(String column, ValType value) {
    _values[column] = value;
    return this;
  }

  InsertStatement setInt(String column, int value) {
    _values[column] = value;
    return this;
  }

  InsertStatement setString(String column, String value) {
    _values[column] = value;
    return this;
  }

  InsertStatement setBool(String column, bool value) {
    _values[column] = value;
    return this;
  }

  InsertStatement setDateTime(String column, DateTime value) {
    _values[column] = value;
    return this;
  }

  InsertStatement setValues(Map<String, dynamic> values) {
    _values.addAll(values);
    return this;
  }

  String toSql() {
    StringBuffer sb = new StringBuffer();

    sb.write('INSERT INTO $_tableName (');

    sb.write(_values.keys.join(', '));

    sb.write(') VALUES (');
    sb.write(_values.values.map(_valToStr).join(', '));
    sb.write(')');

    sb.write(' RETURNING $_id');

    return sb.toString();
  }
}

String _valToStr(dynamic val) {
  if (val is int) {
    return "$val";
  } else if (val is String) {
    return "'$val'";
  } else if (val is double || val is num) {
    return "$val";
  } else if (val is DateTime) {
    return "$val"; //TODO
  } else if (val is bool) {
    return val? 'TRUE': 'FALSE';
  } else {
    throw new Exception("Invalid type!");
  }
}
